# Class VulkanGraphicsPipelineCreateInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanGraphicsPipelineCreateInfo.Builder

Enclosing class:
  `VulkanGraphicsPipelineCreateInfo`

public static final class VulkanGraphicsPipelineCreateInfo.Builder extends Object
Builds instances of type `VulkanGraphicsPipelineCreateInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `addAllFlags(Iterable<VulkanPipelineCreateFlag> elements)`
  Adds elements to `flags` set.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `addAllStages(Iterable<? extends VulkanPipelineShaderStageCreateInfo> elements)`
  Adds elements to `stages` list.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `addFlags(VulkanPipelineCreateFlag element)`
  Adds one element to `flags` set.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `addFlags(VulkanPipelineCreateFlag... elements)`
  Adds elements to `flags` set.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `addStages(VulkanPipelineShaderStageCreateInfo element)`
  Adds one element to `stages` list.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `addStages(VulkanPipelineShaderStageCreateInfo... elements)`
  Adds elements to `stages` list.
  `VulkanGraphicsPipelineCreateInfo`
  `build()`
  Builds a new `VulkanGraphicsPipelineCreateInfo`.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `from(VulkanGraphicsPipelineCreateInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanGraphicsPipelineCreateInfoType` instance.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setBasePipeline(VulkanPipelineType basePipeline)`
  Initializes the optional value `basePipeline` to basePipeline.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setBasePipeline(Optional<? extends VulkanPipelineType> basePipeline)`
  Initializes the optional value `basePipeline` to basePipeline.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setBasePipelineIndex(int basePipelineIndex)`
  Initializes the optional value `basePipelineIndex` to basePipelineIndex.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setBasePipelineIndex(OptionalInt basePipelineIndex)`
  Initializes the optional value `basePipelineIndex` to basePipelineIndex.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setColorBlendState(VulkanPipelineColorBlendStateCreateInfo colorBlendState)`
  Initializes the optional value `colorBlendState` to colorBlendState.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setColorBlendState(Optional<? extends VulkanPipelineColorBlendStateCreateInfo> colorBlendState)`
  Initializes the optional value `colorBlendState` to colorBlendState.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setDepthStencilState(VulkanPipelineDepthStencilStateCreateInfo depthStencilState)`
  Initializes the optional value `depthStencilState` to depthStencilState.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setDepthStencilState(Optional<? extends VulkanPipelineDepthStencilStateCreateInfo> depthStencilState)`
  Initializes the optional value `depthStencilState` to depthStencilState.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setDynamicState(VulkanPipelineDynamicStateCreateInfo dynamicState)`
  Initializes the optional value `dynamicState` to dynamicState.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setDynamicState(Optional<? extends VulkanPipelineDynamicStateCreateInfo> dynamicState)`
  Initializes the optional value `dynamicState` to dynamicState.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setFlags(Iterable<VulkanPipelineCreateFlag> elements)`
  Sets or replaces all elements for `flags` set.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setInputAssemblyState(VulkanPipelineInputAssemblyStateCreateInfo inputAssemblyState)`
  Initializes the value for the `inputAssemblyState` attribute.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setLayout(VulkanPipelineLayoutType layout)`
  Initializes the value for the `layout` attribute.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setMultisampleState(VulkanPipelineMultisampleStateCreateInfo multisampleState)`
  Initializes the optional value `multisampleState` to multisampleState.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setMultisampleState(Optional<? extends VulkanPipelineMultisampleStateCreateInfo> multisampleState)`
  Initializes the optional value `multisampleState` to multisampleState.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setRasterizationState(VulkanPipelineRasterizationStateCreateInfo rasterizationState)`
  Initializes the value for the `rasterizationState` attribute.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setRenderingCreateInfo(VulkanPipelineRenderingCreateInfo renderingCreateInfo)`
  Initializes the optional value `renderingCreateInfo` to renderingCreateInfo.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setRenderingCreateInfo(Optional<? extends VulkanPipelineRenderingCreateInfo> renderingCreateInfo)`
  Initializes the optional value `renderingCreateInfo` to renderingCreateInfo.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setRenderPass(VulkanRenderPassType renderPass)`
  Initializes the optional value `renderPass` to renderPass.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setRenderPass(Optional<? extends VulkanRenderPassType> renderPass)`
  Initializes the optional value `renderPass` to renderPass.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setStages(Iterable<? extends VulkanPipelineShaderStageCreateInfo> elements)`
  Sets or replaces all elements for `stages` list.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setSubpass(int subpass)`
  Initializes the value for the `subpass` attribute.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setTessellationState(VulkanPipelineTessellationStateCreateInfo tessellationState)`
  Initializes the optional value `tessellationState` to tessellationState.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setTessellationState(Optional<? extends VulkanPipelineTessellationStateCreateInfo> tessellationState)`
  Initializes the optional value `tessellationState` to tessellationState.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setVertexInputState(VulkanPipelineVertexInputStateCreateInfo vertexInputState)`
  Initializes the value for the `vertexInputState` attribute.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setViewportState(VulkanPipelineViewportStateCreateInfo viewportState)`
  Initializes the optional value `viewportState` to viewportState.
  `final VulkanGraphicsPipelineCreateInfo.Builder`
  `setViewportState(Optional<? extends VulkanPipelineViewportStateCreateInfo> viewportState)`
  Initializes the optional value `viewportState` to viewportState.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanGraphicsPipelineCreateInfo.Builder from(VulkanGraphicsPipelineCreateInfoType instance)
    Fill a builder with attribute values from the provided `VulkanGraphicsPipelineCreateInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanGraphicsPipelineCreateInfo.Builder addFlags(VulkanPipelineCreateFlag element)
    Adds one element to `flags` set.
    Parameters:
      `element` - A flags element
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanGraphicsPipelineCreateInfo.Builder addFlags(VulkanPipelineCreateFlag... elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An array of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setFlags

    public final VulkanGraphicsPipelineCreateInfo.Builder setFlags(Iterable<VulkanPipelineCreateFlag> elements)
    Sets or replaces all elements for `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllFlags

    public final VulkanGraphicsPipelineCreateInfo.Builder addAllFlags(Iterable<VulkanPipelineCreateFlag> elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addStages

    public final VulkanGraphicsPipelineCreateInfo.Builder addStages(VulkanPipelineShaderStageCreateInfo element)
    Adds one element to `stages` list.
    Parameters:
      `element` - A stages element
    Returns:
      `this` builder for use in a chained invocation

  - ### addStages

    public final VulkanGraphicsPipelineCreateInfo.Builder addStages(VulkanPipelineShaderStageCreateInfo... elements)
    Adds elements to `stages` list.
    Parameters:
      `elements` - An array of stages elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setStages

    public final VulkanGraphicsPipelineCreateInfo.Builder setStages(Iterable<? extends VulkanPipelineShaderStageCreateInfo> elements)
    Sets or replaces all elements for `stages` list.
    Parameters:
      `elements` - An iterable of stages elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllStages

    public final VulkanGraphicsPipelineCreateInfo.Builder addAllStages(Iterable<? extends VulkanPipelineShaderStageCreateInfo> elements)
    Adds elements to `stages` list.
    Parameters:
      `elements` - An iterable of stages elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setVertexInputState

    public final VulkanGraphicsPipelineCreateInfo.Builder setVertexInputState(VulkanPipelineVertexInputStateCreateInfo vertexInputState)
    Initializes the value for the `vertexInputState` attribute.
    Parameters:
      `vertexInputState` - The value for vertexInputState
    Returns:
      `this` builder for use in a chained invocation

  - ### setInputAssemblyState

    public final VulkanGraphicsPipelineCreateInfo.Builder setInputAssemblyState(VulkanPipelineInputAssemblyStateCreateInfo inputAssemblyState)
    Initializes the value for the `inputAssemblyState` attribute.
    Parameters:
      `inputAssemblyState` - The value for inputAssemblyState
    Returns:
      `this` builder for use in a chained invocation

  - ### setTessellationState

    public final VulkanGraphicsPipelineCreateInfo.Builder setTessellationState(VulkanPipelineTessellationStateCreateInfo tessellationState)
    Initializes the optional value `tessellationState` to tessellationState.
    Parameters:
      `tessellationState` - The value for tessellationState
    Returns:
      `this` builder for chained invocation

  - ### setTessellationState

    public final VulkanGraphicsPipelineCreateInfo.Builder setTessellationState(Optional<? extends VulkanPipelineTessellationStateCreateInfo> tessellationState)
    Initializes the optional value `tessellationState` to tessellationState.
    Parameters:
      `tessellationState` - The value for tessellationState
    Returns:
      `this` builder for use in a chained invocation

  - ### setViewportState

    public final VulkanGraphicsPipelineCreateInfo.Builder setViewportState(VulkanPipelineViewportStateCreateInfo viewportState)
    Initializes the optional value `viewportState` to viewportState.
    Parameters:
      `viewportState` - The value for viewportState
    Returns:
      `this` builder for chained invocation

  - ### setViewportState

    public final VulkanGraphicsPipelineCreateInfo.Builder setViewportState(Optional<? extends VulkanPipelineViewportStateCreateInfo> viewportState)
    Initializes the optional value `viewportState` to viewportState.
    Parameters:
      `viewportState` - The value for viewportState
    Returns:
      `this` builder for use in a chained invocation

  - ### setRasterizationState

    public final VulkanGraphicsPipelineCreateInfo.Builder setRasterizationState(VulkanPipelineRasterizationStateCreateInfo rasterizationState)
    Initializes the value for the `rasterizationState` attribute.
    Parameters:
      `rasterizationState` - The value for rasterizationState
    Returns:
      `this` builder for use in a chained invocation

  - ### setMultisampleState

    public final VulkanGraphicsPipelineCreateInfo.Builder setMultisampleState(VulkanPipelineMultisampleStateCreateInfo multisampleState)
    Initializes the optional value `multisampleState` to multisampleState.
    Parameters:
      `multisampleState` - The value for multisampleState
    Returns:
      `this` builder for chained invocation

  - ### setMultisampleState

    public final VulkanGraphicsPipelineCreateInfo.Builder setMultisampleState(Optional<? extends VulkanPipelineMultisampleStateCreateInfo> multisampleState)
    Initializes the optional value `multisampleState` to multisampleState.
    Parameters:
      `multisampleState` - The value for multisampleState
    Returns:
      `this` builder for use in a chained invocation

  - ### setDepthStencilState

    public final VulkanGraphicsPipelineCreateInfo.Builder setDepthStencilState(VulkanPipelineDepthStencilStateCreateInfo depthStencilState)
    Initializes the optional value `depthStencilState` to depthStencilState.
    Parameters:
      `depthStencilState` - The value for depthStencilState
    Returns:
      `this` builder for chained invocation

  - ### setDepthStencilState

    public final VulkanGraphicsPipelineCreateInfo.Builder setDepthStencilState(Optional<? extends VulkanPipelineDepthStencilStateCreateInfo> depthStencilState)
    Initializes the optional value `depthStencilState` to depthStencilState.
    Parameters:
      `depthStencilState` - The value for depthStencilState
    Returns:
      `this` builder for use in a chained invocation

  - ### setColorBlendState

    public final VulkanGraphicsPipelineCreateInfo.Builder setColorBlendState(VulkanPipelineColorBlendStateCreateInfo colorBlendState)
    Initializes the optional value `colorBlendState` to colorBlendState.
    Parameters:
      `colorBlendState` - The value for colorBlendState
    Returns:
      `this` builder for chained invocation

  - ### setColorBlendState

    public final VulkanGraphicsPipelineCreateInfo.Builder setColorBlendState(Optional<? extends VulkanPipelineColorBlendStateCreateInfo> colorBlendState)
    Initializes the optional value `colorBlendState` to colorBlendState.
    Parameters:
      `colorBlendState` - The value for colorBlendState
    Returns:
      `this` builder for use in a chained invocation

  - ### setDynamicState

    public final VulkanGraphicsPipelineCreateInfo.Builder setDynamicState(VulkanPipelineDynamicStateCreateInfo dynamicState)
    Initializes the optional value `dynamicState` to dynamicState.
    Parameters:
      `dynamicState` - The value for dynamicState
    Returns:
      `this` builder for chained invocation

  - ### setDynamicState

    public final VulkanGraphicsPipelineCreateInfo.Builder setDynamicState(Optional<? extends VulkanPipelineDynamicStateCreateInfo> dynamicState)
    Initializes the optional value `dynamicState` to dynamicState.
    Parameters:
      `dynamicState` - The value for dynamicState
    Returns:
      `this` builder for use in a chained invocation

  - ### setLayout

    public final VulkanGraphicsPipelineCreateInfo.Builder setLayout(VulkanPipelineLayoutType layout)
    Initializes the value for the `layout` attribute.
    Parameters:
      `layout` - The value for layout
    Returns:
      `this` builder for use in a chained invocation

  - ### setRenderPass

    public final VulkanGraphicsPipelineCreateInfo.Builder setRenderPass(VulkanRenderPassType renderPass)
    Initializes the optional value `renderPass` to renderPass.
    Parameters:
      `renderPass` - The value for renderPass
    Returns:
      `this` builder for chained invocation

  - ### setRenderPass

    public final VulkanGraphicsPipelineCreateInfo.Builder setRenderPass(Optional<? extends VulkanRenderPassType> renderPass)
    Initializes the optional value `renderPass` to renderPass.
    Parameters:
      `renderPass` - The value for renderPass
    Returns:
      `this` builder for use in a chained invocation

  - ### setSubpass

    public final VulkanGraphicsPipelineCreateInfo.Builder setSubpass(int subpass)
    Initializes the value for the `subpass` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `subpass`.

    Parameters:
      `subpass` - The value for subpass
    Returns:
      `this` builder for use in a chained invocation

  - ### setBasePipeline

    public final VulkanGraphicsPipelineCreateInfo.Builder setBasePipeline(VulkanPipelineType basePipeline)
    Initializes the optional value `basePipeline` to basePipeline.
    Parameters:
      `basePipeline` - The value for basePipeline
    Returns:
      `this` builder for chained invocation

  - ### setBasePipeline

    public final VulkanGraphicsPipelineCreateInfo.Builder setBasePipeline(Optional<? extends VulkanPipelineType> basePipeline)
    Initializes the optional value `basePipeline` to basePipeline.
    Parameters:
      `basePipeline` - The value for basePipeline
    Returns:
      `this` builder for use in a chained invocation

  - ### setBasePipelineIndex

    public final VulkanGraphicsPipelineCreateInfo.Builder setBasePipelineIndex(int basePipelineIndex)
    Initializes the optional value `basePipelineIndex` to basePipelineIndex.
    Parameters:
      `basePipelineIndex` - The value for basePipelineIndex
    Returns:
      `this` builder for chained invocation

  - ### setBasePipelineIndex

    public final VulkanGraphicsPipelineCreateInfo.Builder setBasePipelineIndex(OptionalInt basePipelineIndex)
    Initializes the optional value `basePipelineIndex` to basePipelineIndex.
    Parameters:
      `basePipelineIndex` - The value for basePipelineIndex
    Returns:
      `this` builder for use in a chained invocation

  - ### setRenderingCreateInfo

    public final VulkanGraphicsPipelineCreateInfo.Builder setRenderingCreateInfo(VulkanPipelineRenderingCreateInfo renderingCreateInfo)
    Initializes the optional value `renderingCreateInfo` to renderingCreateInfo.
    Parameters:
      `renderingCreateInfo` - The value for renderingCreateInfo
    Returns:
      `this` builder for chained invocation

  - ### setRenderingCreateInfo

    public final VulkanGraphicsPipelineCreateInfo.Builder setRenderingCreateInfo(Optional<? extends VulkanPipelineRenderingCreateInfo> renderingCreateInfo)
    Initializes the optional value `renderingCreateInfo` to renderingCreateInfo.
    Parameters:
      `renderingCreateInfo` - The value for renderingCreateInfo
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanGraphicsPipelineCreateInfo build()
    Builds a new `VulkanGraphicsPipelineCreateInfo`.
    Returns:
      An immutable instance of VulkanGraphicsPipelineCreateInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing